console.log("[+] Hooking...");

const randomBytes = Process.findModuleByName("SIMSmeCore").findExportByName(
  "_ZN11ChilkatRand11randomBytesEjPh",
);

const r250_table_offset = 0xd6f278;
// 32bit integers / 8 = 4 bytes
const r250_table_size = 250 * 4;
const r250_table_ptr = ptr(Module.getBaseAddress("SIMSmeCore")).add(0xd6f278);
Interceptor.attach(randomBytes, {
  onEnter: function (args) {
    this.dest = args[1];
    console.log("\n!call " + "randomBytes()" + " called");
    console.log(
      "\tBacktrace:\n\t" +
        Thread.backtrace(this.context, Backtracer.ACCURATE)
          .map(DebugSymbol.fromAddress)
          .join("\n\t"),
    );
    console.log("R250 table before:");
    console.log(
      hexdump(Memory.readByteArray(r250_table_ptr, r250_table_size), {
        length: r250_table_size,
        header: true,
        ansi: false,
      }),
    );
  },
  onLeave: function () {
    console.log("randomBytes() output:");
    console.log(
      hexdump(Memory.readByteArray(this.dest, 32), {
        length: 32,
        header: true,
        ansi: false,
      }),
    );
    console.log("R250 table after:");
    console.log(
      hexdump(Memory.readByteArray(r250_table_ptr, r250_table_size), {
        length: r250_table_size,
        header: true,
        ansi: false,
      }),
    );
  },
});

const getNewRawAesKey = Process.findModuleByName("SIMSmeCore").findExportByName(
  "$s10SIMSmeCore21CryptoHelperEncrypterV15getNewRawAesKeySSyKFZ",
);
Interceptor.attach(getNewRawAesKey, {
  onEnter: function (args) {
    console.log("\n!call " + "getNewRawAesKey()" + " called");
    console.log(
      "\tBacktrace:\n\t" +
        Thread.backtrace(this.context, Backtracer.ACCURATE)
          .map(DebugSymbol.fromAddress)
          .join("\n\t"),
    );
  },
});

const databuffer_exlusiveOr_offset = 0x7deaa0;
const data_buffer_exclusiveOr_ptr = ptr(
  Module.getBaseAddress("SIMSmeCore"),
).add(databuffer_exlusiveOr_offset);
// Pkcs1::oaep_decode return address after DataBuffer::exclusiveOr()
const pkcs1_oap_decode_address = "8cd1ac";
Interceptor.attach(data_buffer_exclusiveOr_ptr, {
  onEnter: function (args) {
    console.log("\n!call " + "DataBuffer::exclusiveOr()" + " called");
    this.seed = args[1];
    this.isSeed = false;
    const backtrace = Thread.backtrace(this.context, Backtracer.ACCURATE).map(
      DebugSymbol.fromAddress,
    );

    for (let i = 0; i < backtrace.length; i++) {
      if ((backtrace[i].address & 0xfff) == 0xe88) {
        console.log("Found Pkcs1::oaep_encode() call");
        this.isSeed = true;
        break;
      }
    }
  },
  onLeave: function () {
    //console.log(pointer.add(Process.pointerSize).readPointer().readUtf8String()); // data
    if (this.isSeed) {
      const x = this.seed.add(0x18).readPointer().readByteArray(20);
      console.log("!seed: \n" + hexdump(x, 20), {
        length: 20,
        header: true,
        ansi: false,
      });
    }
  },
});

// ***** CkoCrypt2 *****
// - AesKeyUnwrap:wrappedKeyData:encoding:
// - CkDecryptFile:destFile:
// - CkEncryptFile:destFile:
// - DecryptEncoded:
// - EncryptEncoded:
// - AesKeyWrap:keyData:encoding:
// - CkDecryptFileAsync:destFile:
// - CkEncryptFileAsync:destFile:
// - DecryptBd:
// - DecryptBytes2:szByteData:
// - DecryptBytes:
// - DecryptBytesENC:
// - DecryptSb:sbOut:
// - DecryptSecureENC:secureStr:
// - DecryptStream:
// - DecryptStreamAsync:
// - DecryptString:
// - DecryptStringENC:
// - EncryptBd:
// - EncryptBytes2:szByteData:
// - EncryptBytes:
// - EncryptBytesENC:
// - EncryptSb:bdOut:
// - EncryptSecureENC:
// - EncryptStream:
// - EncryptStreamAsync:
// - EncryptString:
// - EncryptStringENC:
// - GenRandomBytesENC:
// - GetEncodedIV:
// - GetEncodedKey:
// - RandomizeIV
// - RandomizeKey
// - SetEncodedIV:encoding:
// - SetEncodedKey:encoding:
// - SetEncodedSalt:encoding:
const CkoCrypt2 = ObjC.classes.CkoCrypt2;
/*
const fun1 = "- DecryptStringENC:";
const oldImpla = CkoCrypt2[fun1].implementation;
CkoCrypt2[fun1].implementation = ObjC.implement(
  CkoCrypt2[fun1],
  (self, sel, str) => {
    console.log("\n!call" + fun1 + " called");
    console.log("Type of str: " + new ObjC.Object(str).$className);
    console.log("encrypted: " + new ObjC.Object(str).toString());
    const enc_str = oldImpla(self, sel, str);
    console.log("decrypted: " + new ObjC.Object(enc_str).toString());
    return enc_str;
  },
);

const fun2 = "- DecryptBytesENC:";
const oldImplb = CkoCrypt2[fun2].implementation;
CkoCrypt2[fun2].implementation = ObjC.implement(
  CkoCrypt2[fun2],
  (self, sel, str) => {
    console.log("\n!call" + fun2 + " called");
    console.log("Type of str: " + new ObjC.Object(str).$className);
    console.log("encrypted: " + new ObjC.Object(str).toString());
    const enc_str = oldImplb(self, sel, str);
    const enc_str_obj = new ObjC.Object(enc_str);
    const arr = enc_str_obj.bytes().readByteArray(enc_str_obj.length());
    let st = String.fromCharCode.apply(null, new Uint8Array(arr));
    console.log("decrypted: " + st);
    return enc_str;
  },
);

const fun3 = "- DecryptBytes:";
const oldImplc = CkoCrypt2[fun3].implementation;
CkoCrypt2[fun3].implementation = ObjC.implement(
  CkoCrypt2[fun3],
  (self, sel, str) => {
    console.log("\n!call" + fun3 + " called");
    console.log("Type of str: " + new ObjC.Object(str).$className);
    console.log("encrypted: " + new ObjC.Object(str).toString());
    const enc_str = oldImplc(self, sel, str);
    console.log("decrypted: " + new ObjC.Object(enc_str).toString());
    return enc_str;
  },
);*/

// - EncryptBytes:
const fun4 = "- EncryptBytes:";
const oldImpld = CkoCrypt2[fun4].implementation;
CkoCrypt2[fun4].implementation = ObjC.implement(
  CkoCrypt2[fun4],
  (self, sel, str) => {
    console.log("\n!call" + fun4 + " called");
    console.log("Type of str: " + new ObjC.Object(str).$className);
    console.log("plain: " + new ObjC.Object(str).toString());
    const enc_str = oldImpld(self, sel, str);
    console.log("encrypted: " + new ObjC.Object(enc_str).toString());
    return enc_str;
  },
);
// - EncryptBytesENC:
const fun5 = "- EncryptBytesENC:";
const oldImple = CkoCrypt2[fun5].implementation;
CkoCrypt2[fun5].implementation = ObjC.implement(
  CkoCrypt2[fun5],
  (self, sel, str) => {
    console.log("\n!call" + fun5 + " called");
    console.log("Type of str: " + new ObjC.Object(str).$className);
    console.log("plain: " + new ObjC.Object(str).toString());
    const enc_str = oldImple(self, sel, str);
    console.log("encrypted: " + new ObjC.Object(enc_str).toString());
    return enc_str;
  },
);

const fun6 = "- EncryptString:";
const oldImplf = CkoCrypt2[fun6].implementation;
CkoCrypt2[fun6].implementation = ObjC.implement(
  CkoCrypt2[fun6],
  (self, sel, str) => {
    console.log("\n!call" + fun6 + " called");
    console.log("Type of str: " + new ObjC.Object(str).$className);
    console.log("plain: " + new ObjC.Object(str).toString());
    const enc_str = oldImplf(self, sel, str);
    console.log("encrypted: " + new ObjC.Object(enc_str).toString());
    return enc_str;
  },
);

const fun7 = "- EncryptStringENC:";
const oldImplg = CkoCrypt2[fun7].implementation;
CkoCrypt2[fun7].implementation = ObjC.implement(
  CkoCrypt2[fun7],
  (self, sel, str) => {
    console.log("\n!call" + fun7 + " called");
    console.log("Type of str: " + new ObjC.Object(str).$className);
    console.log("plain: " + new ObjC.Object(str).toString());
    const enc_str = oldImplg(self, sel, str);
    console.log("encrypted: " + new ObjC.Object(enc_str).toString());
    return enc_str;
  },
);

// - SetEncodedIV:encoding:
/*const fun8 = "- SetEncodedIV:encoding:";
const oldImplh = CkoCrypt2[fun8].implementation;
CkoCrypt2[fun8].implementation = ObjC.implement(
  CkoCrypt2[fun8],
  (self, sel, str, encoding) => {
    console.log("\n!call" + fun8 + " called");
    console.log(
      "\tBacktrace:\n\t" +
        Thread.backtrace(this.context, Backtracer.ACCURATE)
          .map(DebugSymbol.fromAddress)
          .join("\n\t"),
    );
    console.log("Type of str: " + new ObjC.Object(str).$className);
    console.log("IV: " + new ObjC.Object(str).toString());
    const enc_str = oldImplh(self, sel, str, encoding);
    return enc_str;
  },
);
// - SetEncodedKey:encoding
const fun9 = "- SetEncodedKey:encoding:";
const oldImpli = CkoCrypt2[fun9].implementation;
CkoCrypt2[fun9].implementation = ObjC.implement(
  CkoCrypt2[fun9],
  (self, sel, str, encoding) => {
    console.log(
      "\tBacktrace:\n\t" +
        Thread.backtrace(this.context, Backtracer.ACCURATE)
          .map(DebugSymbol.fromAddress)
          .join("\n\t"),
    );
    console.log("\n!call" + fun9 + " called");
    console.log("Type of str: " + new ObjC.Object(str).$className);
    console.log("key: " + new ObjC.Object(str).toString());
    const enc_str = oldImpli(self, sel, str, encoding);
    return enc_str;
  },
  );*/

// ***** CkoRsa *****
// - DecryptBytesENC:bUsePrivateKey:
// - EncryptBytesENC:bUsePrivateKey:
// - DecryptBd:usePrivateKey:
// - DecryptBytes:bUsePrivateKey:
// - DecryptString:bUsePrivateKey:
// - DecryptStringENC:bUsePrivateKey:
// - EncryptBd:usePrivateKey:
// - EncryptBytes:bUsePrivateKey:
// - EncryptString:bUsePrivateKey:
// - EncryptStringENC:bUsePrivateKey:
// - ImportPublicKey:

const EncryptStringENC = Process.findModuleByName(
  "SIMSmeCore",
).findExportByName("- EncryptStringENC:bUsePrivateKey:");

const CkoRsa = ObjC.classes.CkoRsa;
const oldImpl = CkoRsa["- EncryptStringENC:bUsePrivateKey:"].implementation;
CkoRsa["- EncryptStringENC:bUsePrivateKey:"].implementation = ObjC.implement(
  CkoRsa["- EncryptStringENC:bUsePrivateKey:"],
  (self, sel, str, bUsePrivateKey) => {
    console.log("\n!call" + "EncryptStringENC:bUsePrivateKey: called");
    console.log(
      "\tBacktrace:\n\t" +
        Thread.backtrace(this.context, Backtracer.ACCURATE)
          .map(DebugSymbol.fromAddress)
          .join("\n\t"),
    );
    console.log("Type of str: " + new ObjC.Object(str).$className);
    console.log("string_to_encrypt: " + new ObjC.Object(str).toString());
    const enc_str = oldImpl(self, sel, str, bUsePrivateKey);
    console.log("encrypted string: " + new ObjC.Object(enc_str).toString());
    return enc_str;
  },
);
/*
const oldImpl2 = CkoRsa["- DecryptStringENC:bUsePrivateKey:"].implementation;
CkoRsa["- DecryptStringENC:bUsePrivateKey:"].implementation = ObjC.implement(
  CkoRsa["- DecryptStringENC:bUsePrivateKey:"],
  (self, sel, str, bUsePrivateKey) => {
    console.log("\n!call" + "DecryptStringENC:bUsePrivateKey: called");
    console.log(
      "\tBacktrace:\n\t" +
        Thread.backtrace(this.context, Backtracer.ACCURATE)
          .map(DebugSymbol.fromAddress)
          .join("\n\t"),
    );
    console.log("encrypted string: " + new ObjC.Object(str).toString());
    const dec_str = oldImpl2(self, sel, str, bUsePrivateKey);
    console.log("Type of str: " + new ObjC.Object(dec_str).$className);
    console.log("decrypted string: " + new ObjC.Object(dec_str).toString());
    return dec_str;
  },
);

const oldImpl3 = CkoRsa["- DecryptBytesENC:bUsePrivateKey:"].implementation;
CkoRsa["- DecryptBytesENC:bUsePrivateKey:"].implementation = ObjC.implement(
  CkoRsa["- DecryptBytesENC:bUsePrivateKey:"],
  (self, sel, str, bUsePrivateKey) => {
    console.log("\n!call" + "DecryptBytesENC:bUsePrivateKey: called");
    console.log(
      "\tBacktrace:\n\t" +
        Thread.backtrace(this.context, Backtracer.ACCURATE)
          .map(DebugSymbol.fromAddress)
          .join("\n\t"),
    );
    console.log("encrypted string: " + new ObjC.Object(str).toString());
    const dec_str = oldImpl3(self, sel, str, bUsePrivateKey);
    console.log("Type of str: " + new ObjC.Object(dec_str).$className);
    console.log("decrypted string: " + new ObjC.Object(dec_str).toString());
    return dec_str;
  },
);*/

const fun10 = "- ImportPublicKey:";
const oldImplj = CkoRsa[fun10].implementation;
CkoRsa[fun10].implementation = ObjC.implement(
  CkoRsa[fun10],
  (self, sel, str) => {
    console.log("\n!call" + fun10 + " called");
    console.log("Type of str: " + new ObjC.Object(str).$className);
    console.log("key: " + new ObjC.Object(str).toString());
    const enc_str = oldImplj(self, sel, str);
    return enc_str;
  },
);

const fun11 = "- ImportPrivateKey:";
const oldImplk = CkoRsa[fun11].implementation;
CkoRsa[fun11].implementation = ObjC.implement(
  CkoRsa[fun11],
  (self, sel, str) => {
    console.log("\n!call" + fun11 + " called");
    console.log("Type of str: " + new ObjC.Object(str).$className);
    console.log("key: " + new ObjC.Object(str).toString());
    const enc_str = oldImplk(self, sel, str);
    return enc_str;
  },
);

/*const fun12 = "- ImportPrivateKeyObj:";
const oldImpll = CkoRsa[fun11].implementation;
CkoRsa[fun12].implementation = ObjC.implement(
  CkoRsa[fun12],
  (self, sel, str) => {
    console.log("\n!call" + fun12 + " called");
    console.log("Type of str: " + new ObjC.Object(str).$className);
    console.log("key: " + new ObjC.Object(str).toString());
    const enc_str = oldImpll(self, sel, str);
    return enc_str;
  },
);*/
// Interceptor.attach(EncryptStringENC, {
//   onEnter: function (args) {
//     // const string_to_encrypt = ObjC.Object(args[2]).toString();
//     // console.log("string_to_encrypt: " + string_to_encrypt);
//     console.log("Type of args[2]: " + new ObjC.Object(args[2]).$className);
//     console.log(
//       "\tBacktrace:\n\t" +
//         Thread.backtrace(this.context, Backtracer.ACCURATE)
//           .map(DebugSymbol.fromAddress)
//           .join("\n\t"),
//     );
//   },
//   onLeave: function () {
//     //const retstr = ObjC.Object(retval).toString();
//     //console.log(retstr);
//     console.log("hi");
//   },
// });
